VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.MDIForm MDIForm1 
   BackColor       =   &H8000000C&
   Caption         =   "MdiMru"
   ClientHeight    =   5760
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   7140
   LinkTopic       =   "MDIForm1"
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   3000
      Top             =   240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileMRUSep 
         Caption         =   "-"
         Visible         =   0   'False
      End
      Begin VB.Menu mnuFileMRU 
         Caption         =   "MRU 1"
         Index           =   1
         Visible         =   0   'False
      End
      Begin VB.Menu mnuFileMRU 
         Caption         =   "MRU 2"
         Index           =   2
         Visible         =   0   'False
      End
      Begin VB.Menu mnuFileMRU 
         Caption         =   "MRU 3"
         Index           =   3
         Visible         =   0   'False
      End
      Begin VB.Menu mnuFileMRU 
         Caption         =   "MRU 4"
         Index           =   4
         Visible         =   0   'False
      End
      Begin VB.Menu mnuFileExitSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuWin 
      Caption         =   "&Windows"
      WindowList      =   -1  'True
      Begin VB.Menu mnuWinArrangeIcons 
         Caption         =   "&Arrange Icons"
      End
      Begin VB.Menu mnuWinCascade 
         Caption         =   "&Cascade"
      End
      Begin VB.Menu mnuWinTileHorizontal 
         Caption         =   "Tile &Horizontal"
      End
      Begin VB.Menu mnuWinTileVertical 
         Caption         =   "Tile &Vertical"
      End
      Begin VB.Menu mnuWinMinimizeAll 
         Caption         =   "&Minimize All"
      End
      Begin VB.Menu mnuWinRestoreAll 
         Caption         =   "&Restore All"
      End
   End
End
Attribute VB_Name = "MDIForm1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_FileTitles As Collection
Private m_FileNames As Collection

Private Sub MDIForm_Load()
    dlgFile.Flags = _
        cdlOFNFileMustExist Or _
        cdlOFNHideReadOnly Or _
        cdlOFNLongNames
    dlgFile.CancelError = True
    dlgFile.Filter = "Text Files (*.txt)|*.txt|All Files (*.*)|*.*"
    dlgFile.FilterIndex = 2
    dlgFile.InitDir = App.Path

    LoadMRUList
    ShowMRUList
End Sub
' Add this file to the MRU list.
Private Sub AddToMRUList(ByVal file_title As String, ByVal file_name As String)
Dim i As Integer

    ' Add the entry at the top of the list.
    If m_FileTitles.Count = 0 Then
        m_FileTitles.Add file_title
        m_FileNames.Add file_name
    Else
        m_FileTitles.Add file_title, , 1
        m_FileNames.Add file_name, , 1
    End If

    ' Remove any duplicates.
    For i = m_FileTitles.Count To 2 Step -1
        If m_FileNames(i) = file_name Then
            m_FileTitles.Remove i
            m_FileNames.Remove i
        End If
    Next i

    ' Remove entries beyond four.
    Do While m_FileTitles.Count > 4
        m_FileTitles.Remove 5
        m_FileNames.Remove 5
    Loop

    ' Redisplay the list.
    ShowMRUList

    ' Save the MRU list.
    SaveMRUList
End Sub
' Display the MRU list.
Private Sub ShowMRUList()
Dim i As Integer

    For i = 1 To m_FileTitles.Count
        mnuFileMRU(i).Caption = "&" & Format$(i) & " " & m_FileTitles(i)
        mnuFileMRU(i).Visible = True
    Next i

    ' If any file is visible, display the MRU separator.
    mnuFileMRUSep.Visible = mnuFileMRU(1).Visible
End Sub

' Load the MRU list.
Private Sub LoadMRUList()
Dim i As Integer
Dim txt As String

    Set m_FileTitles = New Collection
    Set m_FileNames = New Collection

    ' Get the MRU files.
    For i = 1 To 4
        txt = GetSetting("MRUDemo", "MRU", "Title" & Format$(i), "")
        If Len(txt) = 0 Then Exit For

        m_FileTitles.Add txt
        m_FileNames.Add GetSetting("MRUDemo", "MRU", "File" & Format$(i), "")
    Next i
End Sub
' Save the MRU list.
Private Sub SaveMRUList()
Dim i As Integer

    ' Save the MRU files.
    For i = 1 To m_FileTitles.Count
        SaveSetting "MRUDemo", "MRU", "Title" & Format$(i), m_FileTitles(i)
        SaveSetting "MRUDemo", "MRU", "File" & Format$(i), m_FileNames(i)
    Next i

    ' Delete any old entries.
    On Error Resume Next
    For i = m_FileTitles.Count + 1 To 4
        DeleteSetting "MRUDemo", "MRU", "Title" & Format$(i)
        DeleteSetting "MRUDemo", "MRU", "File" & Format$(i)
    Next i
End Sub
Private Sub mnuFileExit_Click()
    Unload Me
End Sub



' Open the selected file.
Private Sub mnuFileMRU_Click(Index As Integer)
    LoadFile m_FileTitles(Index), m_FileNames(Index)
End Sub

' Load the file and add it to the MRU list.
Private Sub LoadFile(ByVal file_title As String, ByVal file_name As String)
Dim fnum As Integer
Dim frm As Form1

    On Error GoTo FileLoadError
    fnum = FreeFile
    Open file_name For Input As fnum
    Set frm = New Form1
    frm.txtFile.Text = Input$(LOF(fnum), #fnum)
    Close #fnum

    AddToMRUList file_title, file_name

    frm.Caption = file_title
    frm.Show
    Exit Sub

FileLoadError:
    MsgBox "Error " & Format$(Err.Number) & _
        " reading file." & vbCrLf & Err.Description
    Exit Sub
End Sub

Private Sub mnuFileOpen_Click()
    On Error Resume Next
    dlgFile.ShowOpen

    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & _
            " selecting file." & vbCrLf & Err.Description
        Exit Sub
    End If

    LoadFile dlgFile.FileTitle, dlgFile.FileName
End Sub


Private Sub mnuWinArrangeIcons_Click()
    Me.Arrange vbArrangeIcons
End Sub

Private Sub mnuWinCascade_Click()
    Me.Arrange vbCascade
End Sub


Private Sub mnuWinMinimizeAll_Click()
Dim frm As Form
Dim is_child As Boolean

    For Each frm In Forms
        On Error Resume Next
        is_child = frm.MDIChild
        If Err.Number <> 0 Then is_child = False
        If is_child Then frm.WindowState = vbMinimized
    Next frm
End Sub

Private Sub mnuWinRestoreAll_Click()
Dim frm As Form
Dim is_child As Boolean

    For Each frm In Forms
        On Error Resume Next
        is_child = frm.MDIChild
        If Err.Number <> 0 Then is_child = False
        If is_child Then frm.WindowState = vbNormal
    Next frm

    Me.ZOrder
End Sub


Private Sub mnuWinTileHorizontal_Click()
    Me.Arrange vbTileHorizontal
End Sub


Private Sub mnuWinTileVertical_Click()
    Me.Arrange vbTileVertical
End Sub


